org.apache.hc.core5.http.message

## Interface HeaderValueParser

- All Known Implementing Classes:
    BasicHeaderValueParser

      public interface HeaderValueParser

  Interface for parsing header values into elements. Instances of this interface are expected to be stateless and thread-safe.
  Since:
    4.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `HeaderElement[]` | `parseElements(CharSequence buffer, ParserCursor cursor)` Parses a header value into elements.
    `HeaderElement` | `parseHeaderElement(CharSequence buffer, ParserCursor cursor)` Parses a single header element.
    `NameValuePair` | `parseNameValuePair(CharSequence buffer, ParserCursor cursor)` Parses a name=value specification, where the = and value are optional.
    `NameValuePair[]` | `parseParameters(CharSequence buffer, ParserCursor cursor)` Parses a list of name-value pairs.

- - ### Method Detail

    - #### parseElements

          HeaderElement[] parseElements(CharSequence buffer,
                                        ParserCursor cursor)

      Parses a header value into elements. Parse errors are indicated as `RuntimeException`.
      Parameters:
        `buffer` - buffer holding the header value to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        an array holding all elements of the header value

    - #### parseHeaderElement

          HeaderElement parseHeaderElement(CharSequence buffer,
                                           ParserCursor cursor)

      Parses a single header element. A header element consist of a semicolon-separate list of name=value definitions.
      Parameters:
        `buffer` - buffer holding the element to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        the parsed element

    - #### parseParameters

          NameValuePair[] parseParameters(CharSequence buffer,
                                          ParserCursor cursor)

      Parses a list of name-value pairs. These lists are used to specify parameters to a header element. Parse errors are indicated as `ParseException`.
      Parameters:
        `buffer` - buffer holding the name-value list to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        an array holding all items of the name-value list

    - #### parseNameValuePair

          NameValuePair parseNameValuePair(CharSequence buffer,
                                           ParserCursor cursor)

      Parses a name=value specification, where the = and value are optional.
      Parameters:
        `buffer` - the buffer holding the name-value pair to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        the name-value pair, where the value is `null` if no value is specified

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.